50ad101e89500af01edde00b047b91fc16fdcb81
[git/git.git] / git-fetch.sh
1 #!/bin/sh
2 #
3
4 USAGE='<fetch-options> <repository> <refspec>...'
5 . git-sh-setup
6 . git-parse-remote
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
9
10 LF='
11 '
12 IFS="$LF"
13
14 rloga=fetch
15 no_tags=
16 tags=
17 append=
18 force=
19 verbose=
20 update_head_ok=
21 exec=
22 upload_pack=
23 keep=--thin
24 while case "$#" in 0) break ;; esac
25 do
26 case "$1" in
27 -a|--a|--ap|--app|--appe|--appen|--append)
28 append=t
29 ;;
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
32 shift
33 exec="--exec=$1"
34 upload_pack="-u $1"
35 ;;
36 -f|--f|--fo|--for|--forc|--force)
37 force=t
38 ;;
39 -t|--t|--ta|--tag|--tags)
40 tags=t
41 ;;
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 no_tags=t
44 ;;
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
48 update_head_ok=t
49 ;;
50 -v|--verbose)
51 verbose=Yes
52 ;;
53 -k|--k|--ke|--kee|--keep)
54 keep=--keep
55 ;;
56 --reflog-action=*)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
58 ;;
59 -*)
60 usage
61 ;;
62 *)
63 break
64 ;;
65 esac
66 shift
67 done
68
69 case "$#" in
70 0)
71 origin=$(get_default_remote)
72 test -n "$(get_remote_url ${origin})" ||
73 die "Where do you want to fetch from today?"
74 set x $origin ; shift ;;
75 esac
76
77 remote_nick="$1"
78 remote=$(get_remote_url "$@")
79 refs=
80 rref=
81 rsync_slurped_objects=
82
83 rloga="$rloga $remote_nick"
84 test "$remote_nick" = "$remote" || rloga="$rloga $remote"
85
86 if test "" = "$append"
87 then
88 : >"$GIT_DIR/FETCH_HEAD"
89 fi
90
91 append_fetch_head () {
92 head_="$1"
93 remote_="$2"
94 remote_name_="$3"
95 remote_nick_="$4"
96 local_name_="$5"
97 case "$6" in
98 t) not_for_merge_='not-for-merge' ;;
99 '') not_for_merge_= ;;
100 esac
101
102 # remote-nick is the URL given on the command line (or a shorthand)
103 # remote-name is the $GIT_DIR relative refs/ path we computed
104 # for this refspec.
105
106 # the $note_ variable will be fed to git-fmt-merge-msg for further
107 # processing.
108 case "$remote_name_" in
109 HEAD)
110 note_= ;;
111 refs/heads/*)
112 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
113 note_="branch '$note_' of " ;;
114 refs/tags/*)
115 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
116 note_="tag '$note_' of " ;;
117 refs/remotes/*)
118 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
119 note_="remote branch '$note_' of " ;;
120 *)
121 note_="$remote_name of " ;;
122 esac
123 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
124 remote_="$remote_1_"
125 note_="$note_$remote_"
126
127 # 2.6.11-tree tag would not be happy to be fed to resolve.
128 if git-cat-file commit "$head_" >/dev/null 2>&1
129 then
130 headc_=$(git-rev-parse --verify "$head_^0") || exit
131 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
132 [ "$verbose" ] && echo >&2 "* committish: $head_"
133 [ "$verbose" ] && echo >&2 " $note_"
134 else
135 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
136 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
137 [ "$verbose" ] && echo >&2 " $note_"
138 fi
139 if test "$local_name_" != ""
140 then
141 # We are storing the head locally. Make sure that it is
142 # a fast forward (aka "reverse push").
143 fast_forward_local "$local_name_" "$head_" "$note_"
144 fi
145 }
146
147 fast_forward_local () {
148 mkdir -p "$(dirname "$GIT_DIR/$1")"
149 case "$1" in
150 refs/tags/*)
151 # Tags need not be pointing at commits so there
152 # is no way to guarantee "fast-forward" anyway.
153 if test -f "$GIT_DIR/$1"
154 then
155 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
156 then
157 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
158 else
159 echo >&2 "* $1: updating with $3"
160 git-update-ref -m "$rloga: updating tag" "$1" "$2"
161 fi
162 else
163 echo >&2 "* $1: storing $3"
164 git-update-ref -m "$rloga: storing tag" "$1" "$2"
165 fi
166 ;;
167
168 refs/heads/* | refs/remotes/*)
169 # $1 is the ref being updated.
170 # $2 is the new value for the ref.
171 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
172 if test "$local"
173 then
174 # Require fast-forward.
175 mb=$(git-merge-base "$local" "$2") &&
176 case "$2,$mb" in
177 $local,*)
178 if test -n "$verbose"
179 then
180 echo >&2 "* $1: same as $3"
181 fi
182 ;;
183 *,$local)
184 echo >&2 "* $1: fast forward to $3"
185 echo >&2 " from $local to $2"
186 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
187 ;;
188 *)
189 false
190 ;;
191 esac || {
192 echo >&2 "* $1: does not fast forward to $3;"
193 case ",$force,$single_force," in
194 *,t,*)
195 echo >&2 " forcing update."
196 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
197 ;;
198 *)
199 echo >&2 " not updating."
200 exit 1
201 ;;
202 esac
203 }
204 else
205 echo >&2 "* $1: storing $3"
206 git-update-ref -m "$rloga: storing head" "$1" "$2"
207 fi
208 ;;
209 esac
210 }
211
212 case "$update_head_ok" in
213 '')
214 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
215 ;;
216 esac
217
218 # If --tags (and later --heads or --all) is specified, then we are
219 # not talking about defaults stored in Pull: line of remotes or
220 # branches file, and just fetch those and refspecs explicitly given.
221 # Otherwise we do what we always did.
222
223 reflist=$(get_remote_refs_for_fetch "$@")
224 if test "$tags"
225 then
226 taglist=`IFS=" " &&
227 (
228 git-ls-remote $upload_pack --tags "$remote" ||
229 echo fail ouch
230 ) |
231 while read sha1 name
232 do
233 case "$sha1" in
234 fail)
235 exit 1
236 esac
237 case "$name" in
238 *^*) continue ;;
239 esac
240 if git-check-ref-format "$name"
241 then
242 echo ".${name}:${name}"
243 else
244 echo >&2 "warning: tag ${name} ignored"
245 fi
246 done` || exit
247 if test "$#" -gt 1
248 then
249 # remote URL plus explicit refspecs; we need to merge them.
250 reflist="$reflist$LF$taglist"
251 else
252 # No explicit refspecs; fetch tags only.
253 reflist=$taglist
254 fi
255 fi
256
257 fetch_main () {
258 reflist="$1"
259 refs=
260
261 for ref in $reflist
262 do
263 refs="$refs$LF$ref"
264
265 # These are relative path from $GIT_DIR, typically starting at refs/
266 # but may be HEAD
267 if expr "z$ref" : 'z\.' >/dev/null
268 then
269 not_for_merge=t
270 ref=$(expr "z$ref" : 'z\.\(.*\)')
271 else
272 not_for_merge=
273 fi
274 if expr "z$ref" : 'z+' >/dev/null
275 then
276 single_force=t
277 ref=$(expr "z$ref" : 'z+\(.*\)')
278 else
279 single_force=
280 fi
281 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
282 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
283
284 rref="$rref$LF$remote_name"
285
286 # There are transports that can fetch only one head at a time...
287 case "$remote" in
288 http://* | https://* | ftp://*)
289 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
290 curl_extra_args="-k"
291 fi
292 max_depth=5
293 depth=0
294 head="ref: $remote_name"
295 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
296 do
297 remote_name_quoted=$(@@PERL@@ -e '
298 my $u = $ARGV[0];
299 $u =~ s/^ref:\s*//;
300 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
301 print "$u";
302 ' "$head")
303 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
304 depth=$( expr \( $depth + 1 \) )
305 done
306 expr "z$head" : "z$_x40\$" >/dev/null ||
307 die "Failed to fetch $remote_name from $remote"
308 echo >&2 Fetching "$remote_name from $remote" using http
309 git-http-fetch -v -a "$head" "$remote/" || exit
310 ;;
311 rsync://*)
312 TMP_HEAD="$GIT_DIR/TMP_HEAD"
313 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
314 head=$(git-rev-parse --verify TMP_HEAD)
315 rm -f "$TMP_HEAD"
316 test "$rsync_slurped_objects" || {
317 rsync -av --ignore-existing --exclude info \
318 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
319
320 # Look at objects/info/alternates for rsync -- http will
321 # support it natively and git native ones will do it on
322 # the remote end. Not having that file is not a crime.
323 rsync -q "$remote/objects/info/alternates" \
324 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
325 rm -f "$GIT_DIR/TMP_ALT"
326 if test -f "$GIT_DIR/TMP_ALT"
327 then
328 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
329 while read alt
330 do
331 case "$alt" in 'bad alternate: '*) die "$alt";; esac
332 echo >&2 "Getting alternate: $alt"
333 rsync -av --ignore-existing --exclude info \
334 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
335 done
336 rm -f "$GIT_DIR/TMP_ALT"
337 fi
338 rsync_slurped_objects=t
339 }
340 ;;
341 *)
342 # We will do git native transport with just one call later.
343 continue ;;
344 esac
345
346 append_fetch_head "$head" "$remote" \
347 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
348
349 done
350
351 case "$remote" in
352 http://* | https://* | ftp://* | rsync://* )
353 ;; # we are already done.
354 *)
355 ( : subshell because we muck with IFS
356 IFS=" $LF"
357 (
358 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
359 ) |
360 while read sha1 remote_name
361 do
362 case "$sha1" in
363 failed)
364 echo >&2 "Fetch failure: $remote"
365 exit 1 ;;
366 esac
367 found=
368 single_force=
369 for ref in $refs
370 do
371 case "$ref" in
372 +$remote_name:*)
373 single_force=t
374 not_for_merge=
375 found="$ref"
376 break ;;
377 .+$remote_name:*)
378 single_force=t
379 not_for_merge=t
380 found="$ref"
381 break ;;
382 .$remote_name:*)
383 not_for_merge=t
384 found="$ref"
385 break ;;
386 $remote_name:*)
387 not_for_merge=
388 found="$ref"
389 break ;;
390 esac
391 done
392 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
393 append_fetch_head "$sha1" "$remote" \
394 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
395 done
396 ) || exit ;;
397 esac
398
399 }
400
401 fetch_main "$reflist"
402
403 # automated tag following
404 case "$no_tags$tags" in
405 '')
406 case "$reflist" in
407 *:refs/*)
408 # effective only when we are following remote branch
409 # using local tracking branch.
410 taglist=$(IFS=" " &&
411 git-ls-remote $upload_pack --tags "$remote" |
412 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
413 while read sha1 name
414 do
415 test -f "$GIT_DIR/$name" && continue
416 git-check-ref-format "$name" || {
417 echo >&2 "warning: tag ${name} ignored"
418 continue
419 }
420 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
421 echo >&2 "Auto-following $name"
422 echo ".${name}:${name}"
423 done)
424 esac
425 case "$taglist" in
426 '') ;;
427 ?*)
428 fetch_main "$taglist" ;;
429 esac
430 esac
431
432 # If the original head was empty (i.e. no "master" yet), or
433 # if we were told not to worry, we do not have to check.
434 case ",$update_head_ok,$orig_head," in
435 *,, | t,* )
436 ;;
437 *)
438 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
439 if test "$curr_head" != "$orig_head"
440 then
441 git-update-ref \
442 -m "$rloga: Undoing incorrectly fetched HEAD." \
443 HEAD "$orig_head"
444 die "Cannot fetch into the current branch."
445 fi
446 ;;
447 esac